
Core - Task # 56376

Epic # 55070 (Accepted): Workpackages
Epic # 54851 (Accepted): WP: Workspaces IRRE & MM bugfixes
Story # 54853 (Accepted): As a user I want to correctly create, modify, preview and publish IRRE & MM related workspace changes

Status: Resolved Priority: Should have
Author: Oliver Hader Category: Workspaces
Created: 2014-02-27 Assigned To: Oliver Hader
Updated: 2014-06-17 Due date:
TYPO3 Version: 6.2
PHP Version: 5.3
Complexity:
Sprint Focus:
Subject: Invalid relations of IRRE records in workspaces
Description

    -  general -> always use live id as pointer value
    -  create records -> automatically fill placeholder pointers
    -  copy records -> currently leads to problems with sorting
    -  move records -> follow and create child move placeholders
        -  Add new TCA control section property for placeholder values:
        -  $TCA[<table>]['ctrl']['shadowColumnsForMovePlaceholders']
    -  delete records -> forward delete data in copy(!) process

The related subtasks are put on hold since they had a different approach about one year ago.
These changes are part of this issue now since they need to be processed at the same time, e.g. localization and copy is basically the
same.

Subtasks:
Task # 29278: Lost relations on copying IRRE children in workspaces Rejected
Task # 45132: Faulty translation behavior of IRRE using workspaces Rejected
Task # 45676: Workspace references are not considered Rejected
Task # 45151: IRRE 1n:csv parent records point to workspace placeholder Rejected
Task # 56977: Save current workspace in ReferenceIndex Resolved
Task # 56994: Introduce shadowColumnsForMovePlaceholders property Resolved
Task # 45133: New IRRE parent-child-structures are not removed Closed
Related issues:
related to TCA Reference - Feature # 56749: New TCA control property shadowCo... Closed 2014-03-11
related to Core - Bug # 61750: Child sorting is lost after publishing workspa... Under Review 2014-09-19

Associated revisions
Revision 740b4435 - 2014-03-22 01:55 - Oliver Hader

[BUGFIX] Invalid relations of IRRE records in workspaces

    -  general -> always use live id as pointer value
    -  create records -> automatically fill placeholder pointers
    -  copy records -> currently leads to problems with sorting
    -  move records -> follow and create child move placeholders
    -  delete records -> forward delete data in copy(!) process
    -  ReferenceIndex needs to hold the most specific relations

  since the CommandMap handler is based on this information
    -  ReleationHandler is extended for IRRE references to fetch
  the live default parent pointer automatically (this new
  behaviour can be disabled by public methods for each
  RelationHandler instance)

    -  The method version_swap_procBasedOnFieldType of the version
  DataHandlerHook is completely removed since IRRE records are
  now referenced using the live default parent pointer value

    -  UserTSconfig property options.workspaces.swapMode is set
  to "pages" per default - thus, if a page gets published all
  accordant records on that page are published as well

Resolves: #56376
Releases: 6.2
Change-Id: I75248d10b000de73ca623770f07e8c2e89d4cdd8
Reviewed-on: https://review.typo3.org/27774
Reviewed-by: Oliver Hader
Tested-by: Oliver Hader

History
#1 - 2014-02-27 13:18 - Oliver Hader
- Status changed from New to Accepted

#2 - 2014-02-27 13:26 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27774

#3 - 2014-03-11 23:03 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27774

#4 - 2014-03-12 17:21 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27774

#5 - 2014-03-14 15:22 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27774

#6 - 2014-03-17 15:29 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27774
#7 - 2014-03-17 16:53 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27774

#8 - 2014-03-17 23:33 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27774

#9 - 2014-03-18 22:33 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27774

#10 - 2014-03-21 20:27 - Gerrit Code Review

Patch set 12 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27774

#11 - 2014-03-21 22:43 - Gerrit Code Review

Patch set 13 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27774

#12 - 2014-03-21 23:35 - Gerrit Code Review

Patch set 14 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27774

#13 - 2014-03-22 01:32 - Gerrit Code Review

Patch set 15 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27774

#14 - 2014-03-22 02:30 - Oliver Hader
- Status changed from Under Review to Resolved
- % Done changed from 57 to 100

Applied in changeset commit:740b4435b8b1888527eee3608257f7cdcdea4ce5.
